Subject: Re: [PATCH v3 net-next 2/2] netem: add cell concept to simulate special MAC behavior

From: Hagen Paul Pfeifer <[email-masked]>
Date: Thu, 01 Dec 2011 09:25:20 +0100

On Thu, 01 Dec 2011 04:30:25 +0100, Eric Dumazet wrote:

> Thats a multiply instead of a divide. On many cpus thats a lot faster.

> Think about a super packet (TSO) of 65000 bytes and cell_size=64

I've never imagined that I am going to say the following: you are wrong,

Eric! (ok, maybe you are right ;-)

TSO and Netem is a no-go. With netem you are strongly advised to disable

offloading. I mean TSO will result in _one_ delay of several minutes,

followed by a burst of packets. Instead of packets spaced by several

seconds (with the rate of 1000byte/s) - which is what you wan't.

To sum up: skb->len is _never_ larger as the MTU for (normal, correct)

network emulation setups with netem. This was the assumption why I

preferred the iterative solution over the div/mod solution.

Did I miss something?

Hagen